/*
 *  ALTerator - ALT Linux configuration project
 *
 *  Copyright (c) 2004,2005 ALT Linux Ltd.
 *  Copyright (c) 2004,2005 Alexey Voinov
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */
#include <cache.hh>
#include <map>

namespace
{
	typedef std::map<std::string, std::string> cache_t;
	static cache_t cache;
}

bool in_cache_p(const std::string& id)
{
	cache_t::iterator i = cache.find(id);
	return i != cache.end();
}

std::string cache_get(const std::string& id)
{
	cache_t::iterator i = cache.find(id);
	if(i == cache.end()) throw ;
	return i->second;
}

void cache_remove(const std::string& id)
{
	cache_t::iterator i = cache.find(id);
	if(i != cache.end()) cache.erase(i);
}

void cache_add(const std::string& id, const std::string& response)
{
	cache.insert(make_pair(id, response));
}

void cache_reset(void)
{
	cache.clear();
}
