/*
 *  ALTerator - ALT Linux configuration project
 *
 *  Copyright (c) 2004,2005 ALT Linux Ltd.
 *  Copyright (c) 2004,2005 Alexey Voinov
 *  Copyright (c) 2004,2005 Stanislav Ievlev
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 */
#include <utils/str.hh>

std::string alt::trim_left(const std::string& str, const char *lim)
{
	std::string::size_type pos = str.find_first_not_of(lim);
	return pos == std::string::npos ? "" : str.substr(pos);
}

std::string alt::trim_right(const std::string& str, const char *lim)
{
	std::string::size_type pos = str.find_last_not_of(lim);
	return pos == std::string::npos ? "" : str.substr(0, pos + 1);
}

std::string alt::trim(const std::string& str, const char *lim)
{
	return trim_right(trim_left(str, lim), lim);
}
